RDKit: RDKit::Descriptors Namespace Reference

| RDKit Open-source cheminformatics and machine learning.

Loading...
Searching...
No Matches
Namespaces | Classes | Typedefs | Enumerations | Functions | Variables
RDKit::Descriptors Namespace Reference

## Namespaces
namespace | detail

## Classes
class | CrippenParamCollection
| singleton class for retrieving Crippen parameters More...
class | CrippenParams
| a class used to store Crippen parameters More...
class | DoubleCubicLatticeVolume
class | Properties
| Holds a collection of properties for computation purposes. More...
struct | PropertyFunctor

## Typedefs
typedef Queries::Query< bool, const ROMol &, true > | PROP_BOOL_QUERY
typedef Queries::AndQuery< int, const ROMol &, true > | PROP_AND_QUERY
typedef Queries::OrQuery< int, const ROMol &, true > | PROP_OR_QUERY
typedef Queries::XOrQuery< int, const ROMol &, true > | PROP_XOR_QUERY
typedef Queries::EqualityQuery< double, const ROMol &, true > | PROP_EQUALS_QUERY
typedef Queries::GreaterQuery< double, const ROMol &, true > | PROP_GREATER_QUERY
typedef Queries::GreaterEqualQuery< double, const ROMol &, true > | PROP_GREATEREQUAL_QUERY
typedef Queries::LessQuery< double, const ROMol &, true > | PROP_LESS_QUERY
typedef Queries::LessEqualQuery< double, const ROMol &, true > | PROP_LESSEQUAL_QUERY
typedef Queries::RangeQuery< double, const ROMol &, true > | PROP_RANGE_QUERY

## Enumerations
enum | NumRotatableBondsOptions { Default = -1 , NonStrict = 0 , Strict = 1 , StrictLinkages = 2 }

## Functions
RDKIT_DESCRIPTORS_EXPORT void | AtomFeatVect (const ROMol &, std::vector< double > &res, int atomid=0, bool addchiral=false)
RDKIT_DESCRIPTORS_EXPORT void | AUTOCORR2D (const ROMol &, std::vector< double > &res, const std::string &customAtomPropName="")
RDKIT_DESCRIPTORS_EXPORT double | calcChi0v (const ROMol &mol, bool force=false)
| From equations (5),(9) and (10) of Rev. Comp. Chem. vol 2, 367-422, (1991)
RDKIT_DESCRIPTORS_EXPORT double | calcChi1v (const ROMol &mol, bool force=false)
| From equations (5),(9) and (10) of Rev. Comp. Chem. vol 2, 367-422, (1991)
RDKIT_DESCRIPTORS_EXPORT double | calcChi2v (const ROMol &mol, bool force=false)
| From equations (5),(9) and (10) of Rev. Comp. Chem. vol 2, 367-422, (1991)
RDKIT_DESCRIPTORS_EXPORT double | calcChi3v (const ROMol &mol, bool force=false)
| From equations (5),(9) and (10) of Rev. Comp. Chem. vol 2, 367-422, (1991)
RDKIT_DESCRIPTORS_EXPORT double | calcChi4v (const ROMol &mol, bool force=false)
| From equations (5),(9) and (10) of Rev. Comp. Chem. vol 2, 367-422, (1991)
RDKIT_DESCRIPTORS_EXPORT double | calcChiNv (const ROMol &mol, unsigned int n, bool force=false)
| From equations (5),(9) and (10) of Rev. Comp. Chem. vol 2, 367-422, (1991)
RDKIT_DESCRIPTORS_EXPORT double | calcChi0n (const ROMol &mol, bool force=false)
RDKIT_DESCRIPTORS_EXPORT double | calcChi1n (const ROMol &mol, bool force=false)
RDKIT_DESCRIPTORS_EXPORT double | calcChi2n (const ROMol &mol, bool force=false)
RDKIT_DESCRIPTORS_EXPORT double | calcChi3n (const ROMol &mol, bool force=false)
RDKIT_DESCRIPTORS_EXPORT double | calcChi4n (const ROMol &mol, bool force=false)
RDKIT_DESCRIPTORS_EXPORT double | calcChiNn (const ROMol &mol, unsigned int n, bool force=false)
RDKIT_DESCRIPTORS_EXPORT double | calcHallKierAlpha (const ROMol &mol, std::vector< double > *atomContribs=nullptr)
RDKIT_DESCRIPTORS_EXPORT double | calcKappa1 (const ROMol &mol)
RDKIT_DESCRIPTORS_EXPORT double | calcKappa2 (const ROMol &mol)
RDKIT_DESCRIPTORS_EXPORT double | calcKappa3 (const ROMol &mol)
RDKIT_DESCRIPTORS_EXPORT double | calcPhi (const ROMol &mol)
RDKIT_DESCRIPTORS_EXPORT void | getCrippenAtomContribs (const ROMol &mol, std::vector< double > &logpContribs, std::vector< double > &mrContribs, bool force=false, std::vector< unsigned int > *atomTypes=nullptr, std::vector< std::string > *atomTypeLabels=nullptr)
RDKIT_DESCRIPTORS_EXPORT void | calcCrippenDescriptors (const ROMol &mol, double &logp, double &mr, bool includeHs=true, bool force=false)
| generate Wildman-Crippen LogP and MR estimates for a molecule
RDKIT_DESCRIPTORS_EXPORT double | calcClogP (const ROMol &mol)
| calculate the default Wildman-Crippen LogP for a molecule
RDKIT_DESCRIPTORS_EXPORT double | calcMR (const ROMol &mol)
| calculate the default Wildman-Crippen MR Estimate for a molecule
RDKIT_DESCRIPTORS_EXPORT unsigned int | calcLipinskiHBA (const ROMol &mol)
| calculates the standard Lipinski HBA definition (number of Ns and Os)
RDKIT_DESCRIPTORS_EXPORT unsigned int | calcLipinskiHBD (const ROMol &mol)
RDKIT_DESCRIPTORS_EXPORT unsigned int | calcNumRotatableBonds (const ROMol &mol, NumRotatableBondsOptions useStrictDefinition=Default)
| calculates the number of rotatable bonds
RDKIT_DESCRIPTORS_EXPORT unsigned int | calcNumRotatableBonds (const ROMol &mol, bool strict)
RDKIT_DESCRIPTORS_EXPORT unsigned int | calcNumHBD (const ROMol &mol)
| calculates the number of H-bond donors
RDKIT_DESCRIPTORS_EXPORT unsigned int | calcNumHBA (const ROMol &mol)
| calculates the number of H-bond acceptors
RDKIT_DESCRIPTORS_EXPORT unsigned int | calcNumHeteroatoms (const ROMol &mol)
| calculates the number of heteroatoms
RDKIT_DESCRIPTORS_EXPORT unsigned int | calcNumAmideBonds (const ROMol &mol)
| calculates the number of amide bonds
RDKIT_DESCRIPTORS_EXPORT double | calcFractionCSP3 (const ROMol &mol)
| calculates the fraction of carbons that are SP3 hybridized
RDKIT_DESCRIPTORS_EXPORT unsigned int | calcNumRings (const ROMol &mol)
| calculates the number of SSSR rings
RDKIT_DESCRIPTORS_EXPORT unsigned int | calcNumAromaticRings (const ROMol &mol)
| calculates the number of aromatic SSSR rings
RDKIT_DESCRIPTORS_EXPORT unsigned int | calcNumAliphaticRings (const ROMol &mol)
RDKIT_DESCRIPTORS_EXPORT unsigned int | calcNumSaturatedRings (const ROMol &mol)
| calculates the number of saturated SSSR rings
RDKIT_DESCRIPTORS_EXPORT unsigned int | calcNumHeterocycles (const ROMol &mol)
| calculates the number of SSSR heterocycles
RDKIT_DESCRIPTORS_EXPORT unsigned int | calcNumAromaticHeterocycles (const ROMol &mol)
| calculates the number of aromatic SSSR heterocycles
RDKIT_DESCRIPTORS_EXPORT unsigned int | calcNumAromaticCarbocycles (const ROMol &mol)
| calculates the number of aromatic SSSR carbocycles
RDKIT_DESCRIPTORS_EXPORT unsigned int | calcNumSaturatedHeterocycles (const ROMol &mol)
| calculates the number of saturated SSSR heterocycles
RDKIT_DESCRIPTORS_EXPORT unsigned int | calcNumSaturatedCarbocycles (const ROMol &mol)
| calculates the number of saturated SSSR carbocycles
RDKIT_DESCRIPTORS_EXPORT unsigned int | calcNumAliphaticHeterocycles (const ROMol &mol)
RDKIT_DESCRIPTORS_EXPORT unsigned int | calcNumAliphaticCarbocycles (const ROMol &mol)
RDKIT_DESCRIPTORS_EXPORT unsigned int | calcNumSpiroAtoms (const ROMol &mol, std::vector< unsigned int > *atoms=nullptr)
RDKIT_DESCRIPTORS_EXPORT unsigned int | calcNumBridgeheadAtoms (const ROMol &mol, std::vector< unsigned int > *atoms=nullptr)
RDKIT_DESCRIPTORS_EXPORT unsigned | numAtomStereoCenters (const ROMol &mol)
| calculates the total number of atom stereo centers
RDKIT_DESCRIPTORS_EXPORT unsigned | numUnspecifiedAtomStereoCenters (const ROMol &mol)
RDKIT_DESCRIPTORS_EXPORT void | registerDescriptors ()
| Helper function to register the descriptors with the descriptor service.
RDKIT_DESCRIPTORS_EXPORT double | calcAMW (const ROMol &mol, bool onlyHeavy=false)
RDKIT_DESCRIPTORS_EXPORT unsigned int | calcNumHeavyAtoms (const ROMol &mol)
RDKIT_DESCRIPTORS_EXPORT unsigned int | calcNumAtoms (const ROMol &mol)
RDKIT_DESCRIPTORS_EXPORT double | calcExactMW (const ROMol &mol, bool onlyHeavy=false)
RDKIT_DESCRIPTORS_EXPORT std::string | calcMolFormula (const ROMol &mol, bool separateIsotopes=false, bool abbreviateHIsotopes=true)
RDKIT_DESCRIPTORS_EXPORT double | getLabuteAtomContribs (const ROMol &mol, std::vector< double > &Vi, double &hContrib, bool includeHs=true, bool force=false)
| calculates atomic contributions to Labute's Approximate Surface Area
RDKIT_DESCRIPTORS_EXPORT double | calcLabuteASA (const ROMol &mol, bool includeHs=true, bool force=false)
| calculates Labute's Approximate Surface Area (ASA from MOE)
RDKIT_DESCRIPTORS_EXPORT double | getTPSAAtomContribs (const ROMol &mol, std::vector< double > &Vi, bool force=false, bool includeSandP=false)
| calculates atomic contributions to the TPSA value
RDKIT_DESCRIPTORS_EXPORT double | calcTPSA (const ROMol &mol, bool force=false, bool includeSandP=false)
| calculates the TPSA value for a molecule
RDKIT_DESCRIPTORS_EXPORT std::vector< double > | calcSlogP_VSA (const ROMol &mol, std::vector< double > *bins=nullptr, bool force=false)
RDKIT_DESCRIPTORS_EXPORT std::vector< double > | calcSMR_VSA (const ROMol &mol, std::vector< double > *bins=nullptr, bool force=false)
RDKIT_DESCRIPTORS_EXPORT std::vector< double > | calcPEOE_VSA (const ROMol &mol, std::vector< double > *bins=nullptr, bool force=false)
RDKIT_DESCRIPTORS_EXPORT std::vector< double > | calcCustomProp_VSA (const ROMol &mol, const std::string &customPropName, const std::vector< double > &bins, bool force=false)
RDKIT_DESCRIPTORS_EXPORT std::vector< unsigned int > | calcMQNs (const ROMol &mol, bool force=false)
| calculates MQN descriptors
RDKIT_DESCRIPTORS_EXPORT void | calcOxidationNumbers (const ROMol &mol)
template<class T>
T * | makePropertyQuery (const std::string &name, double what)
RDKIT_DESCRIPTORS_EXPORT PROP_RANGE_QUERY * | makePropertyRangeQuery (const std::string &name, double min, double max)
RDKIT_DESCRIPTORS_EXPORT void | USR (const ROMol &mol, std::vector< double > &descriptor, int confId=-1)
RDKIT_DESCRIPTORS_EXPORT void | USRCAT (const ROMol &mol, std::vector< double > &descriptor, std::vector< std::vector< unsigned int > > &atomIds, int confId=-1)
RDKIT_DESCRIPTORS_EXPORT void | calcUSRDistributions (const RDGeom::Point3DConstPtrVect &coords, std::vector< std::vector< double > > &dist, std::vector< RDGeom::Point3D > &points)
RDKIT_DESCRIPTORS_EXPORT void | calcUSRDistributionsFromPoints (const RDGeom::Point3DConstPtrVect &coords, const std::vector< RDGeom::Point3D > &points, std::vector< std::vector< double > > &dist)
RDKIT_DESCRIPTORS_EXPORT void | calcUSRFromDistributions (const std::vector< std::vector< double > > &dist, std::vector< double > &descriptor)
RDKIT_DESCRIPTORS_EXPORT double | calcUSRScore (const std::vector< double > &d1, const std::vector< double > &d2, const std::vector< double > &weights)

## Variables
const std::string | AtomFeatVersion = "1.0.0"
const std::string | AUTOCORR2DVersion = "1.0.0"
const std::string | chi0vVersion = "1.2.0"
const std::string | chi1vVersion = "1.2.0"
const std::string | chi2vVersion = "1.2.0"
const std::string | chi3vVersion = "1.2.0"
const std::string | chi4vVersion = "1.2.0"
const std::string | chiNvVersion = "1.2.0"
const std::string | chi0nVersion = "1.2.0"
const std::string | chi1nVersion = "1.2.0"
const std::string | chi2nVersion = "1.2.0"
const std::string | chi3nVersion = "1.2.0"
const std::string | chi4nVersion = "1.2.0"
const std::string | chiNnVersion = "1.2.0"
const std::string | hallKierAlphaVersion = "1.2.0"
const std::string | kappa1Version = "1.1.0"
const std::string | kappa2Version = "1.1.0"
const std::string | kappa3Version = "1.1.0"
const std::string | PhiVersion = "1.0.0"
const std::string | crippenVersion = "1.2.0"
const std::string | CrippenClogPVersion = crippenVersion
const std::string | CrippenMRVersion = crippenVersion
const std::string | lipinskiHBAVersion = "1.0.0"
const std::string | lipinskiHBDVersion = "2.0.0"
RDKIT_DESCRIPTORS_EXPORT const std::string | NumRotatableBondsVersion
RDKIT_DESCRIPTORS_EXPORT const std::string | NumHBDVersion
RDKIT_DESCRIPTORS_EXPORT const std::string | NumHBAVersion
RDKIT_DESCRIPTORS_EXPORT const std::string | NumHeteroatomsVersion
RDKIT_DESCRIPTORS_EXPORT const std::string | NumAmideBondsVersion
RDKIT_DESCRIPTORS_EXPORT const std::string | FractionCSP3Version
RDKIT_DESCRIPTORS_EXPORT const std::string | NumRingsVersion
RDKIT_DESCRIPTORS_EXPORT const std::string | NumAromaticRingsVersion
RDKIT_DESCRIPTORS_EXPORT const std::string | NumAliphaticRingsVersion
RDKIT_DESCRIPTORS_EXPORT const std::string | NumSaturatedRingsVersion
RDKIT_DESCRIPTORS_EXPORT const std::string | NumHeterocyclesVersion
RDKIT_DESCRIPTORS_EXPORT const std::string | NumAromaticHeterocyclesVersion
RDKIT_DESCRIPTORS_EXPORT const std::string | NumAromaticCarbocyclesVersion
RDKIT_DESCRIPTORS_EXPORT const std::string | NumSaturatedHeterocyclesVersion
RDKIT_DESCRIPTORS_EXPORT const std::string | NumSaturatedCarbocyclesVersion
RDKIT_DESCRIPTORS_EXPORT const std::string | NumAliphaticHeterocyclesVersion
RDKIT_DESCRIPTORS_EXPORT const std::string | NumAliphaticCarbocyclesVersion
RDKIT_DESCRIPTORS_EXPORT const std::string | NumSpiroAtomsVersion
RDKIT_DESCRIPTORS_EXPORT const std::string | NumBridgeheadAtomsVersion
RDKIT_DESCRIPTORS_EXPORT const std::string | NumAtomStereoCentersVersion
RDKIT_DESCRIPTORS_EXPORT const std::string | NumUnspecifiedAtomStereoCentersVersion
| calculates the number of unspecified stereo atom stereo centers
RDKIT_DESCRIPTORS_EXPORT const std::string | amwVersion
RDKIT_DESCRIPTORS_EXPORT const std::string | NumHeavyAtomsVersion
RDKIT_DESCRIPTORS_EXPORT const std::string | NumAtomsVersion
RDKIT_DESCRIPTORS_EXPORT const std::string | exactmwVersion
const std::string | labuteASAVersion = "1.0.2"
const std::string | tpsaVersion = "2.0.0"
const std::string | MQNVersion = "1.0.0"

## Typedef Documentation

## ◆ PROP_AND_QUERY

typedef Queries::AndQuery<int, const ROMol &, true> RDKit::Descriptors::PROP_AND_QUERY

Definition at line 96 of file Property.h.

## ◆ PROP_BOOL_QUERY

typedef Queries::Query<bool, const ROMol &, true> RDKit::Descriptors::PROP_BOOL_QUERY

Definition at line 95 of file Property.h.

## ◆ PROP_EQUALS_QUERY

typedef Queries::EqualityQuery<double, const ROMol &, true> RDKit::Descriptors::PROP_EQUALS_QUERY

Definition at line 100 of file Property.h.

## ◆ PROP_GREATER_QUERY

typedef Queries::GreaterQuery<double, const ROMol &, true> RDKit::Descriptors::PROP_GREATER_QUERY

Definition at line 102 of file Property.h.

## ◆ PROP_GREATEREQUAL_QUERY

typedef Queries::GreaterEqualQuery<double, const ROMol &, true> RDKit::Descriptors::PROP_GREATEREQUAL_QUERY

Definition at line 105 of file Property.h.

## ◆ PROP_LESS_QUERY

typedef Queries::LessQuery<double, const ROMol &, true> RDKit::Descriptors::PROP_LESS_QUERY

Definition at line 107 of file Property.h.

## ◆ PROP_LESSEQUAL_QUERY

typedef Queries::LessEqualQuery<double, const ROMol &, true> RDKit::Descriptors::PROP_LESSEQUAL_QUERY

Definition at line 110 of file Property.h.

## ◆ PROP_OR_QUERY

typedef Queries::OrQuery<int, const ROMol &, true> RDKit::Descriptors::PROP_OR_QUERY

Definition at line 97 of file Property.h.

## ◆ PROP_RANGE_QUERY

typedef Queries::RangeQuery<double, const ROMol &, true> RDKit::Descriptors::PROP_RANGE_QUERY

Definition at line 112 of file Property.h.

## ◆ PROP_XOR_QUERY

typedef Queries::XOrQuery<int, const ROMol &, true> RDKit::Descriptors::PROP_XOR_QUERY

Definition at line 98 of file Property.h.

## Enumeration Type Documentation

## ◆ NumRotatableBondsOptions

enum RDKit::Descriptors::NumRotatableBondsOptions

Enumerator
Default |
NonStrict |
Strict |
StrictLinkages |

Definition at line 35 of file Lipinski.h.

## Function Documentation

## ◆ AtomFeatVect()

RDKIT_DESCRIPTORS_EXPORT void RDKit::Descriptors::AtomFeatVect | ( | const ROMol & | ,
|  | std::vector< double > & | res,
|  | int | atomid = 0,
|  | bool | addchiral = false )

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ AUTOCORR2D()

RDKIT_DESCRIPTORS_EXPORT void RDKit::Descriptors::AUTOCORR2D | ( | const ROMol & | ,
|  | std::vector< double > & | res,
|  | const std::string & | customAtomPropName = "" )

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcAMW()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::calcAMW | ( | const ROMol & | mol,
|  | bool | onlyHeavy = false )

References NumHeavyAtomsVersion, and RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcChi0n()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::calcChi0n | ( | const ROMol & | mol,
|  | bool | force = false )

Similar to Hall Kier ChiXv, but uses nVal instead of valence This makes a big difference after we get out of the first row.

Parameters

  mol | the molecule of interest
  force | forces the value to be recalculated instead of pulled from the cache

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcChi0v()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::calcChi0v | ( | const ROMol & | mol,
|  | bool | force = false )

From equations (5),(9) and (10) of Rev. Comp. Chem. vol 2, 367-422, (1991)

Parameters

  mol | the molecule of interest
  force | forces the value to be recalculated instead of pulled from the cache

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcChi1n()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::calcChi1n | ( | const ROMol & | mol,
|  | bool | force = false )

Similar to Hall Kier ChiXv, but uses nVal instead of valence This makes a big difference after we get out of the first row.

Parameters

  mol | the molecule of interest
  force | forces the value to be recalculated instead of pulled from the cache

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcChi1v()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::calcChi1v | ( | const ROMol & | mol,
|  | bool | force = false )

From equations (5),(9) and (10) of Rev. Comp. Chem. vol 2, 367-422, (1991)

Parameters

  mol | the molecule of interest
  force | forces the value to be recalculated instead of pulled from the cache

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcChi2n()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::calcChi2n | ( | const ROMol & | mol,
|  | bool | force = false )

Similar to Hall Kier ChiXv, but uses nVal instead of valence This makes a big difference after we get out of the first row.

Parameters

  mol | the molecule of interest
  force | forces the value to be recalculated instead of pulled from the cache

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcChi2v()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::calcChi2v | ( | const ROMol & | mol,
|  | bool | force = false )

From equations (5),(9) and (10) of Rev. Comp. Chem. vol 2, 367-422, (1991)

Parameters

  mol | the molecule of interest
  force | forces the value to be recalculated instead of pulled from the cache

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcChi3n()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::calcChi3n | ( | const ROMol & | mol,
|  | bool | force = false )

Similar to Hall Kier ChiXv, but uses nVal instead of valence This makes a big difference after we get out of the first row.

Parameters

  mol | the molecule of interest
  force | forces the value to be recalculated instead of pulled from the cache

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcChi3v()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::calcChi3v | ( | const ROMol & | mol,
|  | bool | force = false )

From equations (5),(9) and (10) of Rev. Comp. Chem. vol 2, 367-422, (1991)

Parameters

  mol | the molecule of interest
  force | forces the value to be recalculated instead of pulled from the cache

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcChi4n()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::calcChi4n | ( | const ROMol & | mol,
|  | bool | force = false )

Similar to Hall Kier ChiXv, but uses nVal instead of valence This makes a big difference after we get out of the first row.

Parameters

  mol | the molecule of interest
  force | forces the value to be recalculated instead of pulled from the cache

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcChi4v()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::calcChi4v | ( | const ROMol & | mol,
|  | bool | force = false )

From equations (5),(9) and (10) of Rev. Comp. Chem. vol 2, 367-422, (1991)

Parameters

  mol | the molecule of interest
  force | forces the value to be recalculated instead of pulled from the cache

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcChiNn()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::calcChiNn | ( | const ROMol & | mol,
|  | unsigned int | n,
|  | bool | force = false )

Similar to Hall Kier ChiXv, but uses nVal instead of valence This makes a big difference after we get out of the first row.

Parameters

  mol | the molecule of interest
  n | the order of the connectivity index
  force | forces the value to be recalculated instead of pulled from the cache

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcChiNv()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::calcChiNv | ( | const ROMol & | mol,
|  | unsigned int | n,
|  | bool | force = false )

From equations (5),(9) and (10) of Rev. Comp. Chem. vol 2, 367-422, (1991)

Parameters

  mol | the molecule of interest
  n | the order of the connectivity index
  force | forces the value to be recalculated instead of pulled from the cache

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcClogP()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::calcClogP | ( | const ROMol & | mol | ) |

calculate the default Wildman-Crippen LogP for a molecule

See calcCrippenDescriptors

Parameters

  mol | the molecule of interest

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcCrippenDescriptors()

RDKIT_DESCRIPTORS_EXPORT void RDKit::Descriptors::calcCrippenDescriptors | ( | const ROMol & | mol,
|  | double & | logp,
|  | double & | mr,
|  | bool | includeHs = true,
|  | bool | force = false )

generate Wildman-Crippen LogP and MR estimates for a molecule

Uses an atom-based scheme based on the values in the paper: S. A. Wildman and G. M. Crippen JCICS 39 868-873 (1999)

Parameters

  mol | the molecule of interest
  logp | used to return the logp estimate
  mr | used to return the MR estimate
  includeHs | (optional) if this is true (the default), a copy of `mol` is made and Hs are added to it. If false, Hs that are not explicitly present in the graph will not be included.
  force | forces the value to be recalculated instead of pulled from the cache

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcCustomProp_VSA()

RDKIT_DESCRIPTORS_EXPORT std::vector< double > RDKit::Descriptors::calcCustomProp_VSA | ( | const ROMol & | mol,
|  | const std::string & | customPropName,
|  | const std::vector< double > & | bins,
|  | bool | force = false )

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcExactMW()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::calcExactMW | ( | const ROMol & | mol,
|  | bool | onlyHeavy = false )

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcFractionCSP3()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::calcFractionCSP3 | ( | const ROMol & | mol | ) |

calculates the fraction of carbons that are SP3 hybridized

References NumRingsVersion, and RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcHallKierAlpha()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::calcHallKierAlpha | ( | const ROMol & | mol,
|  | std::vector< double > * | atomContribs = nullptr )

calculate the Hall-Kier alpha value for a molecule From equation (58) of Rev. Comp. Chem. vol 2, 367-422, (1991)

Note
  Because hybridization is used to calculate this, results may differ from other implementations which have different conventions for assigning hybridization

Parameters

  mol | the molecule of interest
  atomContribs | if provided, this will be used to return the contributions of the individual atoms to the value. These do not necessarily sum to the full value. Note: this can be a time-consuming calculation.

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcKappa1()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::calcKappa1 | ( | const ROMol & | mol | ) |

calculate the Hall-Kier kappa1 value for a molecule From equations (58) and (59) of Rev. Comp. Chem. vol 2, 367-422, (1991)

Note
  Because hybridization is used to calculate this, results may differ from other implementations which have different conventions for assigning hybridization

Parameters

  mol | the molecule of interest

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcKappa2()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::calcKappa2 | ( | const ROMol & | mol | ) |

calculate the Hall-Kier kappa2 value for a molecule From equations (58) and (60) of Rev. Comp. Chem. vol 2, 367-422, (1991)

Note
  Because hybridization is used to calculate this results may differ from other implementations which have different conventions for assigning hybridization

Parameters

  mol | the molecule of interest

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcKappa3()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::calcKappa3 | ( | const ROMol & | mol | ) |

calculate the Hall-Kier kappa3 value for a molecule From equations (58), (61) and (62) of Rev. Comp. Chem. vol 2, 367-422, 1991)

Note
  Because hybridization is used to calculate this results may differ from other implementations which have different conventions for assigning hybridization

Parameters

  mol | the molecule of interest

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcLabuteASA()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::calcLabuteASA | ( | const ROMol & | mol,
|  | bool | includeHs = true,
|  | bool | force = false )

calculates Labute's Approximate Surface Area (ASA from MOE)

Definition from P. Labute's article in the Journal of the Chemical Computing Group and J. Mol. Graph. Mod. 18 464-477 (2000)

Parameters

  mol | the molecule of interest
  includeHs | (optional) if this is true (the default), the contribution of H atoms to the ASA will be included.
  force | (optional) calculate the value even if it's cached.

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcLipinskiHBA()

RDKIT_DESCRIPTORS_EXPORT unsigned int RDKit::Descriptors::calcLipinskiHBA | ( | const ROMol & | mol | ) |

calculates the standard Lipinski HBA definition (number of Ns and Os)

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcLipinskiHBD()

RDKIT_DESCRIPTORS_EXPORT unsigned int RDKit::Descriptors::calcLipinskiHBD | ( | const ROMol & | mol | ) |

calculates the standard Lipinski HBA definition (number of N-H and O-H bonds)

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcMolFormula()

RDKIT_DESCRIPTORS_EXPORT std::string RDKit::Descriptors::calcMolFormula | ( | const ROMol & | mol,
|  | bool | separateIsotopes = false,
|  | bool | abbreviateHIsotopes = true )

Calculates a molecule's formula

Parameters

  mol | the molecule of interest
  separateIsotopes | if true, isotopes will show up separately in the formula. So C[13CH2]O will give the formula: C[13C]H6O
  abbreviateHIsotopes | if true, 2H and 3H will be represented as D and T instead of [2H] and [3H]. This only applies if `separateIsotopes` is true

Returns
  the formula as a string

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcMQNs()

RDKIT_DESCRIPTORS_EXPORT std::vector< unsigned int > RDKit::Descriptors::calcMQNs | ( | const ROMol & | mol,
|  | bool | force = false )

calculates MQN descriptors

Definition from Nguyen, K. T., Blum, L. C., Van Deursen, R. & Reymond, J.-L. "Classification of Organic Molecules by Molecular Quantum Numbers." ChemMedChem 4, 1803–1805 (2009).

Parameters

  mol | the molecule of interest
  force | (optional) calculate the values even if they are cached.

Returns
  a vector with the MQNs

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcMR()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::calcMR | ( | const ROMol & | mol | ) |

calculate the default Wildman-Crippen MR Estimate for a molecule

See calcCrippenDescriptors

Parameters

  mol | the molecule of interest

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcNumAliphaticCarbocycles()

RDKIT_DESCRIPTORS_EXPORT unsigned int RDKit::Descriptors::calcNumAliphaticCarbocycles | ( | const ROMol & | mol | ) |

calculates the number of aliphatic (at least one non-aromatic bond) SSSR carbocycles

References NumSpiroAtomsVersion, and RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcNumAliphaticHeterocycles()

RDKIT_DESCRIPTORS_EXPORT unsigned int RDKit::Descriptors::calcNumAliphaticHeterocycles | ( | const ROMol & | mol | ) |

calculates the number of aliphatic (at least one non-aromatic bond) SSSR heterocycles

References NumAliphaticCarbocyclesVersion, and RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcNumAliphaticRings()

RDKIT_DESCRIPTORS_EXPORT unsigned int RDKit::Descriptors::calcNumAliphaticRings | ( | const ROMol & | mol | ) |

calculates the number of aliphatic (at least one non-aromatic bond) SSSR rings

References NumSaturatedRingsVersion, and RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcNumAmideBonds()

RDKIT_DESCRIPTORS_EXPORT unsigned int RDKit::Descriptors::calcNumAmideBonds | ( | const ROMol & | mol | ) |

calculates the number of amide bonds

References FractionCSP3Version, and RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcNumAromaticCarbocycles()

RDKIT_DESCRIPTORS_EXPORT unsigned int RDKit::Descriptors::calcNumAromaticCarbocycles | ( | const ROMol & | mol | ) |

calculates the number of aromatic SSSR carbocycles

References NumSaturatedHeterocyclesVersion, and RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcNumAromaticHeterocycles()

RDKIT_DESCRIPTORS_EXPORT unsigned int RDKit::Descriptors::calcNumAromaticHeterocycles | ( | const ROMol & | mol | ) |

calculates the number of aromatic SSSR heterocycles

References NumAromaticCarbocyclesVersion, and RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcNumAromaticRings()

RDKIT_DESCRIPTORS_EXPORT unsigned int RDKit::Descriptors::calcNumAromaticRings | ( | const ROMol & | mol | ) |

calculates the number of aromatic SSSR rings

References NumAliphaticRingsVersion, and RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcNumAtoms()

RDKIT_DESCRIPTORS_EXPORT unsigned int RDKit::Descriptors::calcNumAtoms | ( | const ROMol & | mol | ) |

References exactmwVersion, and RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcNumBridgeheadAtoms()

RDKIT_DESCRIPTORS_EXPORT unsigned int RDKit::Descriptors::calcNumBridgeheadAtoms | ( | const ROMol & | mol,
|  | std::vector< unsigned int > * | atoms = nullptr )

calculates the number of bridgehead atoms (atoms shared between rings that share at least two bonds)

References NumAtomStereoCentersVersion, and RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcNumHBA()

RDKIT_DESCRIPTORS_EXPORT unsigned int RDKit::Descriptors::calcNumHBA | ( | const ROMol & | mol | ) |

calculates the number of H-bond acceptors

References NumHeteroatomsVersion, and RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcNumHBD()

RDKIT_DESCRIPTORS_EXPORT unsigned int RDKit::Descriptors::calcNumHBD | ( | const ROMol & | mol | ) |

calculates the number of H-bond donors

References NumHBAVersion, and RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcNumHeavyAtoms()

RDKIT_DESCRIPTORS_EXPORT unsigned int RDKit::Descriptors::calcNumHeavyAtoms | ( | const ROMol & | mol | ) |

References NumAtomsVersion, and RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcNumHeteroatoms()

RDKIT_DESCRIPTORS_EXPORT unsigned int RDKit::Descriptors::calcNumHeteroatoms | ( | const ROMol & | mol | ) |

calculates the number of heteroatoms

References NumAmideBondsVersion, and RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcNumHeterocycles()

RDKIT_DESCRIPTORS_EXPORT unsigned int RDKit::Descriptors::calcNumHeterocycles | ( | const ROMol & | mol | ) |

calculates the number of SSSR heterocycles

References NumAromaticHeterocyclesVersion, and RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcNumRings()

RDKIT_DESCRIPTORS_EXPORT unsigned int RDKit::Descriptors::calcNumRings | ( | const ROMol & | mol | ) |

calculates the number of SSSR rings

References NumAromaticRingsVersion, and RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcNumRotatableBonds() [1/2]

RDKIT_DESCRIPTORS_EXPORT unsigned int RDKit::Descriptors::calcNumRotatableBonds | ( | const ROMol & | mol,
|  | bool | strict )

calculates the number of rotatable bonds ( backwards compatibility function, deprecated, please use calcNumRotatableBonds(const ROMol&, int)

Parameters

  mol | the molecule of interest
  strict | if Strict == true, uses NumRotatableBondsOptions::Strict

References NumHBDVersion, and RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcNumRotatableBonds() [2/2]

RDKIT_DESCRIPTORS_EXPORT unsigned int RDKit::Descriptors::calcNumRotatableBonds | ( | const ROMol & | mol,
|  | NumRotatableBondsOptions | useStrictDefinition = Default )

calculates the number of rotatable bonds

Parameters

  mol | the molecule of interest
  strict | if Strict, a stricter definition of rotable bonds is used this excludes amides, esters, etc. if StrictLinkages, a much stricter definition that handles rotatable bonds between rings as well. if Default - uses the default choice (normally Strict)

References Default, and RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcNumSaturatedCarbocycles()

RDKIT_DESCRIPTORS_EXPORT unsigned int RDKit::Descriptors::calcNumSaturatedCarbocycles | ( | const ROMol & | mol | ) |

calculates the number of saturated SSSR carbocycles

References NumAliphaticHeterocyclesVersion, and RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcNumSaturatedHeterocycles()

RDKIT_DESCRIPTORS_EXPORT unsigned int RDKit::Descriptors::calcNumSaturatedHeterocycles | ( | const ROMol & | mol | ) |

calculates the number of saturated SSSR heterocycles

References NumSaturatedCarbocyclesVersion, and RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcNumSaturatedRings()

RDKIT_DESCRIPTORS_EXPORT unsigned int RDKit::Descriptors::calcNumSaturatedRings | ( | const ROMol & | mol | ) |

calculates the number of saturated SSSR rings

References NumHeterocyclesVersion, and RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcNumSpiroAtoms()

RDKIT_DESCRIPTORS_EXPORT unsigned int RDKit::Descriptors::calcNumSpiroAtoms | ( | const ROMol & | mol,
|  | std::vector< unsigned int > * | atoms = nullptr )

calculates the number of spiro atoms (atoms shared between rings that share exactly one atom)

References NumBridgeheadAtomsVersion, and RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcOxidationNumbers()

RDKIT_DESCRIPTORS_EXPORT void RDKit::Descriptors::calcOxidationNumbers | ( | const ROMol & | mol | ) |

Calculates the oxidation numbers (states) of the atoms in a molecule and stores them in the property _OxidationNumber on the atoms. Uses Pauling electronegativies. This is experimental code, still under development.

Parameters

  mol | the molecule of interest

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcPEOE_VSA()

RDKIT_DESCRIPTORS_EXPORT std::vector< double > RDKit::Descriptors::calcPEOE_VSA | ( | const ROMol & | mol,
|  | std::vector< double > * | bins = nullptr,
|  | bool | force = false )

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcPhi()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::calcPhi | ( | const ROMol & | mol | ) |

calculate the Kier Phi value for a molecule From Quantitative Structure-Activity Relationships 8, 221–224 (1989).

Note
  Because hybridization is used to calculate this results may differ from other implementations which have different conventions for assigning hybridization

Parameters

  mol | the molecule of interest

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcSlogP_VSA()

RDKIT_DESCRIPTORS_EXPORT std::vector< double > RDKit::Descriptors::calcSlogP_VSA | ( | const ROMol & | mol,
|  | std::vector< double > * | bins = nullptr,
|  | bool | force = false )

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcSMR_VSA()

RDKIT_DESCRIPTORS_EXPORT std::vector< double > RDKit::Descriptors::calcSMR_VSA | ( | const ROMol & | mol,
|  | std::vector< double > * | bins = nullptr,
|  | bool | force = false )

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcTPSA()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::calcTPSA | ( | const ROMol & | mol,
|  | bool | force = false,
|  | bool | includeSandP = false )

calculates the TPSA value for a molecule

The TPSA definition is from: P. Ertl, B. Rohde, P. Selzer Fast Calculation of Molecular Polar Surface Area as a Sum of Fragment-based Contributions and Its Application to the Prediction of Drug Transport Properties, J.Med.Chem. 43, 3714-3717, 2000 By default the calculation does not include contributions from S or P atoms, this can be be changed with the includeSandP argument.

Parameters

  mol | the molecule of interest
  force | (optional) calculate the value even if it's cached.
  includeSandP | (optional) include contributions from S and P atoms

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcUSRDistributions()

RDKIT_DESCRIPTORS_EXPORT void RDKit::Descriptors::calcUSRDistributions | ( | const RDGeom::Point3DConstPtrVect & | coords,
|  | std::vector< std::vector< double > > & | dist,
|  | std::vector< RDGeom::Point3D > & | points )

Calculates the four distance distributions for the USR descriptor

Parameters

  coords | the atom coordinates
  dist | storage for the four distance distributions
  points | storage for the four points

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcUSRDistributionsFromPoints()

RDKIT_DESCRIPTORS_EXPORT void RDKit::Descriptors::calcUSRDistributionsFromPoints | ( | const RDGeom::Point3DConstPtrVect & | coords,
|  | const std::vector< RDGeom::Point3D > & | points,
|  | std::vector< std::vector< double > > & | dist )

Calculates the four distance distributions for the USR descriptor

Parameters

  coords | the atom coordinates
  points | vector with the points
  dist | storage for the distance distributions

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcUSRFromDistributions()

RDKIT_DESCRIPTORS_EXPORT void RDKit::Descriptors::calcUSRFromDistributions | ( | const std::vector< std::vector< double > > & | dist,
|  | std::vector< double > & | descriptor )

Calculates the USR descriptor from the four distance distributions

Parameters

  dist | vector with the four distance distributions
  descriptor | storage for the computed USR descriptor

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ calcUSRScore()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::calcUSRScore | ( | const std::vector< double > & | d1,
|  | const std::vector< double > & | d2,
|  | const std::vector< double > & | weights )

Calculates the score between two USRCAT descriptors with weights

Parameters

  d1 | descriptor 1
  d2 | descriptor 2
  weights | the weights for each subset of moments

Returns
  the score

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ getCrippenAtomContribs()

RDKIT_DESCRIPTORS_EXPORT void RDKit::Descriptors::getCrippenAtomContribs | ( | const ROMol & | mol,
|  | std::vector< double > & | logpContribs,
|  | std::vector< double > & | mrContribs,
|  | bool | force = false,
|  | std::vector< unsigned int > * | atomTypes = nullptr,
|  | std::vector< std::string > * | atomTypeLabels = nullptr )

generate atomic contributions to the Wildman-Crippen LogP and MR estimates for a molecule

Uses an atom-based scheme based on the values in the paper: S. A. Wildman and G. M. Crippen JCICS 39 868-873 (1999)

Parameters

  mol | the molecule of interest
  logpContribs | used to return the logp contributions, must be equal in length to the number of atoms
  mrContribs | used to return the MR contributions, must be equal in length to the number of atoms
  force | forces the value to be recalculated instead of pulled from the cache
  atomTypes | if provided will be used to return the indices of the atom types, should be as long as the number of atoms
  atomTypeLabels | if provided will be used to return the labels of the atom types, should be as long as the number of atoms

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ getLabuteAtomContribs()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::getLabuteAtomContribs | ( | const ROMol & | mol,
|  | std::vector< double > & | Vi,
|  | double & | hContrib,
|  | bool | includeHs = true,
|  | bool | force = false )

calculates atomic contributions to Labute's Approximate Surface Area

Definition from P. Labute's article in the Journal of the Chemical Computing Group and J. Mol. Graph. Mod. 18 464-477 (2000)

Parameters

  mol | the molecule of interest
  Vi | used to return the explicit atom contribs
  hContrib | used to return the H contributions (if calculated)
  includeHs | (optional) if this is true (the default), the contribution of H atoms to the ASA will be included.
  force | (optional) calculate the values even if they are cached.

Returns
  the sum of the atomic contributions

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ getTPSAAtomContribs()

RDKIT_DESCRIPTORS_EXPORT double RDKit::Descriptors::getTPSAAtomContribs | ( | const ROMol & | mol,
|  | std::vector< double > & | Vi,
|  | bool | force = false,
|  | bool | includeSandP = false )

calculates atomic contributions to the TPSA value

The TPSA definition is from: P. Ertl, B. Rohde, P. Selzer Fast Calculation of Molecular Polar Surface Area as a Sum of Fragment-based Contributions and Its Application to the Prediction of Drug Transport Properties, J.Med.Chem. 43, 3714-3717, 2000 By default the calculation does not include contributions from S or P atoms, this can be be changed with the includeSandP argument.

Parameters

  mol | the molecule of interest
  Vi | used to return the atom contribs
  force | (optional) calculate the values even if they are cached.
  includeSandP | (optional) include contributions from S and P atoms

Returns
  the sum of the atomic contributions

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ makePropertyQuery()

template<class T>

T * RDKit::Descriptors::makePropertyQuery | ( | const std::string & | name,
|  | double | what )

Definition at line 115 of file Property.h.

References RDKit::Descriptors::Properties::getProperty().

## ◆ makePropertyRangeQuery()

RDKIT_DESCRIPTORS_EXPORT PROP_RANGE_QUERY * RDKit::Descriptors::makePropertyRangeQuery | ( | const std::string & | name,
|  | double | min,
|  | double | max )

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ numAtomStereoCenters()

RDKIT_DESCRIPTORS_EXPORT unsigned RDKit::Descriptors::numAtomStereoCenters | ( | const ROMol & | mol | ) |

calculates the total number of atom stereo centers

References NumUnspecifiedAtomStereoCentersVersion, and RDKIT_DESCRIPTORS_EXPORT.

## ◆ numUnspecifiedAtomStereoCenters()

RDKIT_DESCRIPTORS_EXPORT unsigned RDKit::Descriptors::numUnspecifiedAtomStereoCenters | ( | const ROMol & | mol | ) |

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ registerDescriptors()

RDKIT_DESCRIPTORS_EXPORT void RDKit::Descriptors::registerDescriptors | ( |  | ) |

Helper function to register the descriptors with the descriptor service.

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ USR()

RDKIT_DESCRIPTORS_EXPORT void RDKit::Descriptors::USR | ( | const ROMol & | mol,
|  | std::vector< double > & | descriptor,
|  | int | confId = -1 )

Calculates the ultra-fast shape recognition (USR) descriptor

Reference: P. J. Ballester, W. G. Richards, JCC (2007), 28, 1711 - 1723.

Derived from RDKit Python implementation of Jan Domanski who derived his code from Adrian Schreyer's code: http://hg.adrianschreyer.eu/usrcat/src/70e075d93cd2?at=default

Parameters

  mol | the molecule of interest
  descriptor | storage for the computed USR descriptor
  confId | the conformer Id

References RDKIT_DESCRIPTORS_EXPORT.

## ◆ USRCAT()

RDKIT_DESCRIPTORS_EXPORT void RDKit::Descriptors::USRCAT | ( | const ROMol & | mol,
|  | std::vector< double > & | descriptor,
|  | std::vector< std::vector< unsigned int > > & | atomIds,
|  | int | confId = -1 )

Calculates the ultra-fast shape recognition with CREDO atom types (USRCAT) descriptor

Reference: A. M. Schreyer, T. Blundell, J. Cheminf. (2012), 4, 27.

Derived from Python implementation Adrian Schreyer: http://hg.adrianschreyer.eu/usrcat/src/70e075d93cd2?at=default

Parameters

  mol | the molecule of interest
  descriptor | storage for the computed USR descriptor
  confId | the conformer Id

References RDKIT_DESCRIPTORS_EXPORT.

## Variable Documentation

## ◆ amwVersion

RDKIT_DESCRIPTORS_EXPORT const std::string RDKit::Descriptors::amwVersion
| extern

Calculates a molecule's average molecular weight

Parameters

  mol | the molecule of interest
  onlyHeavy | (optional) if this is true (the default is false), only heavy atoms will be included in the MW calculation

Returns
  the AMW

## ◆ AtomFeatVersion

const std::string RDKit::Descriptors::AtomFeatVersion = "1.0.0"

Definition at line 31 of file AtomFeat.h.

## ◆ AUTOCORR2DVersion

const std::string RDKit::Descriptors::AUTOCORR2DVersion = "1.0.0"

Definition at line 43 of file AUTOCORR2D.h.

## ◆ chi0nVersion

const std::string RDKit::Descriptors::chi0nVersion = "1.2.0"

Definition at line 87 of file ConnectivityDescriptors.h.

## ◆ chi0vVersion

const std::string RDKit::Descriptors::chi0vVersion = "1.2.0"

Definition at line 35 of file ConnectivityDescriptors.h.

## ◆ chi1nVersion

const std::string RDKit::Descriptors::chi1nVersion = "1.2.0"

Definition at line 96 of file ConnectivityDescriptors.h.

## ◆ chi1vVersion

const std::string RDKit::Descriptors::chi1vVersion = "1.2.0"

Definition at line 43 of file ConnectivityDescriptors.h.

## ◆ chi2nVersion

const std::string RDKit::Descriptors::chi2nVersion = "1.2.0"

Definition at line 105 of file ConnectivityDescriptors.h.

## ◆ chi2vVersion

const std::string RDKit::Descriptors::chi2vVersion = "1.2.0"

Definition at line 51 of file ConnectivityDescriptors.h.

## ◆ chi3nVersion

const std::string RDKit::Descriptors::chi3nVersion = "1.2.0"

Definition at line 114 of file ConnectivityDescriptors.h.

## ◆ chi3vVersion

const std::string RDKit::Descriptors::chi3vVersion = "1.2.0"

Definition at line 59 of file ConnectivityDescriptors.h.

## ◆ chi4nVersion

const std::string RDKit::Descriptors::chi4nVersion = "1.2.0"

Definition at line 123 of file ConnectivityDescriptors.h.

## ◆ chi4vVersion

const std::string RDKit::Descriptors::chi4vVersion = "1.2.0"

Definition at line 67 of file ConnectivityDescriptors.h.

## ◆ chiNnVersion

const std::string RDKit::Descriptors::chiNnVersion = "1.2.0"

Definition at line 134 of file ConnectivityDescriptors.h.

## ◆ chiNvVersion

const std::string RDKit::Descriptors::chiNvVersion = "1.2.0"

Definition at line 77 of file ConnectivityDescriptors.h.

## ◆ CrippenClogPVersion

const std::string RDKit::Descriptors::CrippenClogPVersion = crippenVersion

Definition at line 89 of file Crippen.h.

## ◆ CrippenMRVersion

const std::string RDKit::Descriptors::CrippenMRVersion = crippenVersion

Definition at line 97 of file Crippen.h.

## ◆ crippenVersion

const std::string RDKit::Descriptors::crippenVersion = "1.2.0"

Definition at line 27 of file Crippen.h.

## ◆ exactmwVersion

RDKIT_DESCRIPTORS_EXPORT const std::string RDKit::Descriptors::exactmwVersion
| extern

Calculates a molecule's exact molecular weight

Parameters

  mol | the molecule of interest
  onlyHeavy | (optional) if this is true (the default is false), only heavy atoms will be included in the MW calculation

Returns
  the exact MW

Referenced by calcNumAtoms().

## ◆ FractionCSP3Version

RDKIT_DESCRIPTORS_EXPORT const std::string RDKit::Descriptors::FractionCSP3Version
| extern

Referenced by calcNumAmideBonds().

## ◆ hallKierAlphaVersion

const std::string RDKit::Descriptors::hallKierAlphaVersion = "1.2.0"

Definition at line 152 of file ConnectivityDescriptors.h.

## ◆ kappa1Version

const std::string RDKit::Descriptors::kappa1Version = "1.1.0"

Definition at line 164 of file ConnectivityDescriptors.h.

## ◆ kappa2Version

const std::string RDKit::Descriptors::kappa2Version = "1.1.0"

Definition at line 176 of file ConnectivityDescriptors.h.

## ◆ kappa3Version

const std::string RDKit::Descriptors::kappa3Version = "1.1.0"

Definition at line 189 of file ConnectivityDescriptors.h.

## ◆ labuteASAVersion

const std::string RDKit::Descriptors::labuteASAVersion = "1.0.2"

Definition at line 25 of file MolSurf.h.

## ◆ lipinskiHBAVersion

const std::string RDKit::Descriptors::lipinskiHBAVersion = "1.0.0"

Definition at line 26 of file Lipinski.h.

## ◆ lipinskiHBDVersion

const std::string RDKit::Descriptors::lipinskiHBDVersion = "2.0.0"

Definition at line 30 of file Lipinski.h.

## ◆ MQNVersion

const std::string RDKit::Descriptors::MQNVersion = "1.0.0"

Definition at line 25 of file MQN.h.

## ◆ NumAliphaticCarbocyclesVersion

RDKIT_DESCRIPTORS_EXPORT const std::string RDKit::Descriptors::NumAliphaticCarbocyclesVersion
| extern

Referenced by calcNumAliphaticHeterocycles().

## ◆ NumAliphaticHeterocyclesVersion

RDKIT_DESCRIPTORS_EXPORT const std::string RDKit::Descriptors::NumAliphaticHeterocyclesVersion
| extern

Referenced by calcNumSaturatedCarbocycles().

## ◆ NumAliphaticRingsVersion

RDKIT_DESCRIPTORS_EXPORT const std::string RDKit::Descriptors::NumAliphaticRingsVersion
| extern

Referenced by calcNumAromaticRings().

## ◆ NumAmideBondsVersion

RDKIT_DESCRIPTORS_EXPORT const std::string RDKit::Descriptors::NumAmideBondsVersion
| extern

Referenced by calcNumHeteroatoms().

## ◆ NumAromaticCarbocyclesVersion

RDKIT_DESCRIPTORS_EXPORT const std::string RDKit::Descriptors::NumAromaticCarbocyclesVersion
| extern

Referenced by calcNumAromaticHeterocycles().

## ◆ NumAromaticHeterocyclesVersion

RDKIT_DESCRIPTORS_EXPORT const std::string RDKit::Descriptors::NumAromaticHeterocyclesVersion
| extern

Referenced by calcNumHeterocycles().

## ◆ NumAromaticRingsVersion

RDKIT_DESCRIPTORS_EXPORT const std::string RDKit::Descriptors::NumAromaticRingsVersion
| extern

Referenced by calcNumRings().

## ◆ NumAtomStereoCentersVersion

RDKIT_DESCRIPTORS_EXPORT const std::string RDKit::Descriptors::NumAtomStereoCentersVersion
| extern

Referenced by calcNumBridgeheadAtoms().

## ◆ NumAtomsVersion

RDKIT_DESCRIPTORS_EXPORT const std::string RDKit::Descriptors::NumAtomsVersion
| extern

Calculates a molecule's number of atoms

Parameters

  mol | the molecule of interest

Returns
  the number of atoms

Referenced by calcNumHeavyAtoms().

## ◆ NumBridgeheadAtomsVersion

RDKIT_DESCRIPTORS_EXPORT const std::string RDKit::Descriptors::NumBridgeheadAtomsVersion
| extern

Referenced by calcNumSpiroAtoms().

## ◆ NumHBAVersion

RDKIT_DESCRIPTORS_EXPORT const std::string RDKit::Descriptors::NumHBAVersion
| extern

Referenced by calcNumHBD().

## ◆ NumHBDVersion

RDKIT_DESCRIPTORS_EXPORT const std::string RDKit::Descriptors::NumHBDVersion
| extern

Referenced by calcNumRotatableBonds().

## ◆ NumHeavyAtomsVersion

RDKIT_DESCRIPTORS_EXPORT const std::string RDKit::Descriptors::NumHeavyAtomsVersion
| extern

Calculates a molecule's number of heavy (non-hydrogen) atoms

Parameters

  mol | the molecule of interest

Returns
  the number of heavy atoms

Referenced by calcAMW().

## ◆ NumHeteroatomsVersion

RDKIT_DESCRIPTORS_EXPORT const std::string RDKit::Descriptors::NumHeteroatomsVersion
| extern

Referenced by calcNumHBA().

## ◆ NumHeterocyclesVersion

RDKIT_DESCRIPTORS_EXPORT const std::string RDKit::Descriptors::NumHeterocyclesVersion
| extern

Referenced by calcNumSaturatedRings().

## ◆ NumRingsVersion

RDKIT_DESCRIPTORS_EXPORT const std::string RDKit::Descriptors::NumRingsVersion
| extern

Referenced by calcFractionCSP3().

## ◆ NumRotatableBondsVersion

RDKIT_DESCRIPTORS_EXPORT const std::string RDKit::Descriptors::NumRotatableBondsVersion
| extern

## ◆ NumSaturatedCarbocyclesVersion

RDKIT_DESCRIPTORS_EXPORT const std::string RDKit::Descriptors::NumSaturatedCarbocyclesVersion
| extern

Referenced by calcNumSaturatedHeterocycles().

## ◆ NumSaturatedHeterocyclesVersion

RDKIT_DESCRIPTORS_EXPORT const std::string RDKit::Descriptors::NumSaturatedHeterocyclesVersion
| extern

Referenced by calcNumAromaticCarbocycles().

## ◆ NumSaturatedRingsVersion

RDKIT_DESCRIPTORS_EXPORT const std::string RDKit::Descriptors::NumSaturatedRingsVersion
| extern

Referenced by calcNumAliphaticRings().

## ◆ NumSpiroAtomsVersion

RDKIT_DESCRIPTORS_EXPORT const std::string RDKit::Descriptors::NumSpiroAtomsVersion
| extern

Referenced by calcNumAliphaticCarbocycles().

## ◆ NumUnspecifiedAtomStereoCentersVersion

RDKIT_DESCRIPTORS_EXPORT const std::string RDKit::Descriptors::NumUnspecifiedAtomStereoCentersVersion
| extern

calculates the number of unspecified stereo atom stereo centers

Referenced by numAtomStereoCenters().

## ◆ PhiVersion

const std::string RDKit::Descriptors::PhiVersion = "1.0.0"

Definition at line 201 of file ConnectivityDescriptors.h.

## ◆ tpsaVersion

const std::string RDKit::Descriptors::tpsaVersion = "2.0.0"

Definition at line 65 of file MolSurf.h.